VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsSQLScomposer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
'Variable  private
Private SQLpars As SQLParams  'collection of SQL clauses

'Property Variables:
Private m_SQLInputString    As String
Private m_SQLParameters     As String
Private m_SQLTransform      As String
Private m_SQLUpdate         As String
Private m_SQLInsertInto     As String
Private m_SQLDelete         As String
Private m_SQLSelect         As String
Private m_SQLFrom           As String
Private m_SQLPreference     As String
Private m_SQLNoconsole      As Boolean
Private m_SQLPlain          As Boolean
Private m_SQLNoWait         As Boolean
Private m_SQLWhere          As String
Private m_SQLGroupBy        As String
Private m_SQLHaving         As String
Private m_SQLUnion          As String
Private m_SQLOrderBy        As String
Private m_SQLPivot          As String
Private m_SQLOutputString   As String

Private bSQLShape           As Boolean
Private strRestOfSQL        As String

Private Sub Class_Initialize()

  InitSQLParameters
  
  m_SQLInputString = ""
  m_SQLParameters = ""
  m_SQLTransform = ""
  m_SQLUpdate = ""
  m_SQLInsertInto = ""
  m_SQLDelete = ""
  m_SQLSelect = ""
  m_SQLFrom = ""
  m_SQLPreference = ""
  m_SQLNoconsole = False
  m_SQLPlain = False
  m_SQLNoWait = False
  m_SQLWhere = ""
  m_SQLGroupBy = ""
  m_SQLHaving = ""
  m_SQLUnion = ""
  m_SQLOrderBy = ""
  m_SQLOutputString = ""
  m_SQLPivot = ""
  
End Sub

Public Property Get SQLInputString() As String
  SQLInputString = m_SQLInputString
End Property

Public Property Let SQLInputString(ByVal New_SQLInputString As String)
Dim n1 As Integer, n2 As Integer

   m_SQLInputString = New_SQLInputString
   If Right(Trim(m_SQLInputString), 1) <> ";" Then
      m_SQLInputString = m_SQLInputString & ";"
   End If
   
   n1 = InStr(UCase(m_SQLInputString), "SHAPE ")
   If n1 > 0 Then
      'this is an hierachial SQL
      bSQLShape = True
      n1 = InStr(n1, UCase(m_SQLInputString), "{")
      n2 = InStr(n1, UCase(m_SQLInputString), "}")
      m_SQLInputString = Mid(m_SQLInputString, n1 + 1, n2 - (n1 + 1))
      ' for future use
      strRestOfSQL = Mid(New_SQLInputString, n2 + 1)
   End If
   
   SQLScomposer
   SQLComposer
End Property

Public Property Get SQLParameters() As String
  SQLParameters = m_SQLParameters
End Property

Public Property Let SQLParameters(ByVal New_SQLParameters As String)
  m_SQLParameters = New_SQLParameters
  SQLpars(1).Value = m_SQLParameters
  SQLComposer
End Property


Public Property Get SQLTransform() As String
  SQLTransform = m_SQLTransform
End Property

Public Property Let SQLTransform(ByVal New_SQLTransform As String)
  m_SQLTransform = New_SQLTransform
  SQLpars(2).Value = m_SQLTransform
  SQLComposer
End Property

Public Property Get SQLUpdate() As String
  SQLUpdate = m_SQLUpdate
End Property

Public Property Let SQLUpdate(ByVal New_SQLUpdate As String)
  m_SQLUpdate = New_SQLUpdate
  SQLpars(3).Value = m_SQLUpdate
  SQLComposer
End Property

Public Property Get SQLInsertInto() As String
  SQLInsertInto = m_SQLInsertInto
End Property

Public Property Let SQLInsertInto(ByVal New_SQLInsertInto As String)
  m_SQLInsertInto = New_SQLInsertInto
  SQLpars(4).Value = m_SQLInsertInto
  SQLComposer
End Property

Public Property Get SQLDelete() As String
  SQLDelete = m_SQLDelete
End Property

Public Property Let SQLDelete(ByVal New_SQLDelete As String)
  m_SQLDelete = New_SQLDelete
  SQLpars(5).Value = m_SQLDelete
  SQLComposer
End Property

Public Property Get SQLSelect() As String
  SQLSelect = Replace(m_SQLSelect, "DISTINCT ", "")
End Property

Public Property Let SQLSelect(ByVal New_SQLSelect As String)
  m_SQLSelect = New_SQLSelect
  SQLpars(6).Value = m_SQLSelect
  SQLComposer
End Property

Public Property Get SQLFrom() As String
  SQLFrom = m_SQLFrom
End Property

Public Property Let SQLFrom(ByVal New_SQLFrom As String)
  m_SQLFrom = New_SQLFrom
  SQLpars(7).Value = m_SQLFrom
  SQLComposer
End Property

Public Property Get SQLPreference() As String
  SQLPreference = m_SQLPreference
End Property

Public Property Let SQLPreference(ByVal New_SQLPreference As String)
  m_SQLPreference = New_SQLPreference
  SQLpars(8).Value = m_SQLPreference
  SQLComposer
End Property

Public Property Get SQLNoconsole() As Boolean
  SQLNoconsole = m_SQLNoconsole
End Property

Public Property Let SQLNoconsole(ByVal New_SQLNoconsole As Boolean)
  m_SQLNoconsole = New_SQLNoconsole
  If m_SQLNoconsole Then
    SQLpars(9).Value = "NOCONSOLE"
  Else: SQLpars(9).Value = ""
  End If
  SQLComposer
End Property

Public Property Get SQLPlain() As Boolean
  SQLPlain = m_SQLPlain
End Property

Public Property Let SQLPlain(ByVal New_SQLPlain As Boolean)
  m_SQLPlain = New_SQLPlain
  If m_SQLPlain Then
    SQLpars(10).Value = "PLAIN"
  Else: SQLpars(10).Value = ""
  End If
  SQLComposer
End Property

Public Property Get SQLNoWait() As Boolean
  SQLNoWait = m_SQLNoWait
End Property

Public Property Let SQLNoWait(ByVal New_SQLNoWait As Boolean)
  m_SQLNoWait = New_SQLNoWait
  If m_SQLNoWait Then
    SQLpars(11).Value = "NOWAIT"
  Else: SQLpars(11).Value = ""
  End If
  SQLComposer
End Property

Public Property Get SQLWhere() As String
  SQLWhere = m_SQLWhere
End Property

Public Property Let SQLWhere(ByVal New_SQLWhere As String)
  m_SQLWhere = New_SQLWhere
  SQLpars(12).Value = m_SQLWhere
  SQLComposer
End Property

Public Property Get SQLGroupBy() As String
  SQLGroupBy = m_SQLGroupBy
End Property

Public Property Let SQLGroupBy(ByVal New_SQLGroupBy As String)
  m_SQLGroupBy = New_SQLGroupBy
  SQLpars(13).Value = m_SQLGroupBy
  SQLComposer
End Property

Public Property Get SQLHaving() As String
  SQLHaving = m_SQLHaving
End Property

Public Property Let SQLHaving(ByVal New_SQLHaving As String)
  m_SQLHaving = New_SQLHaving
  SQLpars(14).Value = m_SQLHaving
  SQLComposer
End Property

Public Property Get SQLUnion() As String
  SQLUnion = m_SQLUnion
End Property

Public Property Let SQLUnion(ByVal New_SQLUnion As String)
  m_SQLUnion = New_SQLUnion
  SQLpars(15).Value = m_SQLUnion
  SQLComposer
End Property

Public Property Get SQLOrderBy() As String
  SQLOrderBy = m_SQLOrderBy
End Property

Public Property Let SQLOrderBy(ByVal New_SQLOrderBy As String)
  m_SQLOrderBy = New_SQLOrderBy
  SQLpars(16).Value = m_SQLOrderBy
  SQLComposer
End Property

Public Property Get SQLPivot() As String
  SQLPivot = m_SQLPivot
End Property

Public Property Let SQLPivot(ByVal New_SQLPivot As String)
  m_SQLPivot = New_SQLPivot
  SQLpars(17).Value = m_SQLPivot
  SQLComposer
End Property

Public Property Get SQLOutputString() As String

   m_SQLOutputString = Replace(m_SQLOutputString, ";", "")
   
   If bSQLShape Then
      SQLOutputString = "SHAPE {" & m_SQLOutputString & "}" & strRestOfSQL
   Else
     SQLOutputString = m_SQLOutputString
   End If
   
   If Right(Trim(SQLOutputString), 1) <> ";" Then
      SQLOutputString = SQLOutputString & ";"
   End If
   
End Property

Public Property Let SQLOutputString(ByVal New_SQLOutputString As String)
  m_SQLOutputString = New_SQLOutputString
End Property

Private Sub InitSQLParameters()
  Set SQLpars = New SQLParams
  SQLpars.Add "PARAMETERS ", 1, ""
  SQLpars.Add "TRANSFORM ", 2, ""
  SQLpars.Add "UPDATE ", 3, ""
  SQLpars.Add "INSERT INTO ", 4, ""
  SQLpars.Add "DELETE ", 5, ""
  SQLpars.Add "SELECT ", 6, ""
  SQLpars.Add "FROM ", 7, ""
  SQLpars.Add "PREFERENCE ", 8, ""
  SQLpars.Add "NOCONSOLE ", 9, ""
  SQLpars.Add "PLAIN ", 10, ""
  SQLpars.Add "NOWAIT ", 11, ""
  SQLpars.Add "WHERE ", 12, ""
  SQLpars.Add "GROUP BY ", 13, ""
  SQLpars.Add "HAVING ", 14, ""
  SQLpars.Add "UNION ", 15, ""
  SQLpars.Add "ORDER BY ", 16, ""
  SQLpars.Add "PIVOT ", 17, ""
  SQLpars.Add ";", 18, ""         'end of statement SQL
End Sub

Private Sub SQLScomposer()
Dim DaParametro   As Long
Dim AParametro    As Long
Dim PosInizio     As Long
Dim PosFine       As Long
Dim PosCorrente   As Long

  DaParametro = 0
  AParametro = 0
  PosInizio = 1
  'find the first clause in SQLinputstring
  Do
    DaParametro = DaParametro + 1
    PosCorrente = InStr(PosInizio, UCase(m_SQLInputString), UCase(SQLpars(DaParametro).Key))
    If PosCorrente > 0 Then
      'find the next clause to obtain the end of the current clause
      PosInizio = PosCorrente + Len(SQLpars(DaParametro).Key)
      AParametro = DaParametro
      Do
        AParametro = AParametro + 1
        PosCorrente = InStr(PosInizio + 1, UCase(m_SQLInputString), UCase(SQLpars(AParametro).Key))
        If PosCorrente > 0 Then
          PosFine = PosCorrente - 1
          'asing the current clause
          SQLpars(DaParametro).Value = Trim(Mid(m_SQLInputString, PosInizio, PosFine - PosInizio + 1))
          If Right(SQLpars(DaParametro).Value, 1) = ";" Then SQLpars(DaParametro).Value = Left(SQLpars(DaParametro).Value, Len(SQLpars(DaParametro).Value) - 1)
          DaParametro = AParametro - 1
          PosInizio = PosFine
          Exit Do
        Else
          SQLpars(AParametro).Value = ""
        End If
      Loop Until AParametro > SQLpars.Count - 1
    Else
      SQLpars(DaParametro).Value = ""
    End If
  Loop Until DaParametro > SQLpars.Count - 2
    
  ' set the properties
  SQLLoadParamInControl
End Sub

Private Sub SQLLoadParamInControl()
  m_SQLParameters = SQLpars(1).Value
  m_SQLTransform = SQLpars(2).Value
  m_SQLUpdate = SQLpars(3).Value
  m_SQLInsertInto = SQLpars(4).Value
  m_SQLDelete = SQLpars(5).Value
  m_SQLSelect = SQLpars(6).Value
  m_SQLFrom = SQLpars(7).Value
  m_SQLPreference = SQLpars(8).Value
  If Len(SQLpars(9).Value) > 0 Then m_SQLNoconsole = True Else m_SQLNoconsole = False
  If Len(SQLpars(10).Value) > 0 Then m_SQLPlain = True Else m_SQLPlain = False
  If Len(SQLpars(11).Value) > 0 Then m_SQLNoWait = True Else m_SQLNoWait = False
  m_SQLWhere = SQLpars(12).Value
  m_SQLGroupBy = SQLpars(13).Value
  m_SQLHaving = SQLpars(14).Value
  m_SQLUnion = SQLpars(15).Value
  m_SQLOrderBy = SQLpars(16).Value
  m_SQLPivot = SQLpars(17).Value
  SQLComposer
End Sub

Private Sub SQLComposer()
Dim ParametroCorrente As Long

  m_SQLOutputString = ""
  For ParametroCorrente = 1 To SQLpars.Count - 1
    Select Case ParametroCorrente
      Case 1 To 8, 12 To 17    'string
        If Len(SQLpars(ParametroCorrente).Value) > 0 Then
          m_SQLOutputString = m_SQLOutputString & SQLpars(ParametroCorrente).Key & SQLpars(ParametroCorrente).Value & " "
          'find the command to close with ';'
          Select Case ParametroCorrente
            Case 1: 'Parameters:
              Mid(m_SQLOutputString, Len(m_SQLOutputString), 1) = ";"
              m_SQLOutputString = m_SQLOutputString + " "
          End Select
        End If
      Case 9 To 11             'flags
        If Len(SQLpars(ParametroCorrente).Value) > 0 Then
          m_SQLOutputString = m_SQLOutputString & SQLpars(ParametroCorrente).Key & " "
        End If
    End Select
  Next ParametroCorrente

  If Len(m_SQLOutputString) > 0 Then
    If Right(m_SQLOutputString, "1") <> ";" Then Mid(m_SQLOutputString, Len(m_SQLOutputString), 1) = ";"
  End If
End Sub

